#ifndef __BSP_LED_H__
#define __BSP_LED_H__

#include "CONFIG.h"

#define LED_ALARM_R_BPIN GPIO_Pin_8
#define LED_RUN_G_BPIN   GPIO_Pin_9
#define LED_FAULT_Y_APIN GPIO_Pin_1
#define LED_VBAT_R_APIN  GPIO_Pin_7

/**********LED_ALARM_R_BPIN**************/
#define LED_ALARM_R_ON                                        \
    do                                                        \
    {                                                         \
        GPIOB_SetBits(LED_ALARM_R_BPIN);                      \
        GPIOB_ModeCfg(LED_ALARM_R_BPIN, GPIO_ModeOut_PP_5mA); \
    } while (0);

#define LED_ALARM_R_OFF                                  \
    do                                                   \
    {                                                    \
        GPIOB_ResetBits(LED_ALARM_R_BPIN);               \
        GPIOB_ModeCfg(LED_ALARM_R_BPIN, GPIO_ModeIN_PD); \
    } while (0);

/**********LED_RUN_G_BPIN**************/
#define LED_RUN_G_ON                                        \
    do                                                      \
    {                                                       \
        GPIOB_SetBits(LED_RUN_G_BPIN);                      \
        GPIOB_ModeCfg(LED_RUN_G_BPIN, GPIO_ModeOut_PP_5mA); \
    } while (0);

#define LED_RUN_G_OFF                               \
    do                                                 \
    {                                                  \
        GPIOB_ResetBits(LED_RUN_G_BPIN);               \
        GPIOB_ModeCfg(LED_RUN_G_BPIN, GPIO_ModeIN_PD); \
    } while (0);

/**********LED_FAULT_Y_APIN**************/
#define LED_FAULT_Y_ON                                        \
    do                                                        \
    {                                                         \
        GPIOA_SetBits(LED_FAULT_Y_APIN);                      \
        GPIOA_ModeCfg(LED_FAULT_Y_APIN, GPIO_ModeOut_PP_5mA); \
    } while (0);

#define LED_FAULT_Y_OFF do                           \
    {                                                    \
        GPIOA_ResetBits(LED_FAULT_Y_APIN);               \
        GPIOA_ModeCfg(LED_FAULT_Y_APIN, GPIO_ModeIN_PD); \
    }                                                    \
    while (0);

/**********LED_VBAT_R_APIN**************/
#define LED_VBAT_R_ON                                        \
    do                                                       \
    {                                                        \
        GPIOA_SetBits(LED_VBAT_R_APIN);                      \
        GPIOA_ModeCfg(LED_VBAT_R_APIN, GPIO_ModeOut_PP_5mA); \
    } while (0);

#define LED_VBAT_R_OFF                                  \
    do                                                  \
    {                                                   \
        GPIOA_ResetBits(LED_VBAT_R_APIN);               \
        GPIOA_ModeCfg(LED_VBAT_R_APIN, GPIO_ModeIN_PD); \
    } while (0);

#define LED_VALVE_OPEN                                                         \
    do                                                                         \
    {                                                                          \
        GPIOB_ResetBits(LED_ALARM_R_BPIN | LED_RUN_G_BPIN);                    \
        GPIOB_SetBits(LED_RUN_G_BPIN);                                         \
        GPIOB_ModeCfg(LED_ALARM_R_BPIN | LED_RUN_G_BPIN, GPIO_ModeOut_PP_5mA); \
    } while (0);

#define LED_VALVE_CLOSE                                                        \
    do                                                                         \
    {                                                                          \
        GPIOB_ResetBits(LED_ALARM_R_BPIN | LED_RUN_G_BPIN);                    \
        GPIOB_SetBits(LED_ALARM_R_BPIN);                                       \
        GPIOB_ModeCfg(LED_ALARM_R_BPIN | LED_RUN_G_BPIN, GPIO_ModeOut_PP_5mA); \
    } while (0);

/**********LED_ALARM**************/
#define LED_ALARM_OPEN                                        \
    do                                                        \
    {                                                         \
        GPIOA_SetBits(LED_FAULT_Y_APIN);                      \
        GPIOA_ModeCfg(LED_FAULT_Y_APIN, GPIO_ModeOut_PP_5mA); \
    } while (0);

#define LED_ALARM_CLOSE                                       \
    do                                                        \
    {                                                         \
        GPIOA_ResetBits(LED_FAULT_Y_APIN);                    \
        GPIOA_ModeCfg(LED_FAULT_Y_APIN, GPIO_ModeOut_PP_5mA); \
    } while (0);

/**********LED_VBAT**************/
#define LED_VBAT_OPEN                                        \
    do                                                       \
    {                                                        \
        GPIOA_SetBits(LED_VBAT_R_APIN);                      \
        GPIOA_ModeCfg(LED_VBAT_R_APIN, GPIO_ModeOut_PP_5mA); \
    } while (0);

#define LED_VBAT_CLOSE                                       \
    do                                                       \
    {                                                        \
        GPIOA_ResetBits(LED_VBAT_R_APIN);                    \
        GPIOA_ModeCfg(LED_VBAT_R_APIN, GPIO_ModeOut_PP_5mA); \
    } while (0);

extern tmosTaskID led_task_id;

void BSP_LED_AllOn(void);
void BSP_LED_AllOff(void);

void BSP_LED_Init(void);

#endif /* __BSP_LED_H__ */
