/*
 * bsp_led.c
 *
 *  Created on: 20241216
 *      Author: 123
 */
#include "bsp_led.h"

#include "bsp_uart.h"
#include "log.h"

#undef LOG_ENABLE
#define LOG_ENABLE 1

#define LOG_LVL    LOG_DEBUG

#undef LOG_TAG
#define LOG_TAG "led"

tmosTaskID led_task_id = INVALID_TASK_ID;

static tmosEvents LED_Task_ProcessEvent(tmosTaskID taskID, tmosEvents event)
{


}

void BSP_LED_AllOn(void)
{
    LED_ALARM_R_ON;
    LED_RUN_G_ON;
    LED_FAULT_Y_ON;
    LED_VBAT_R_ON;;
}

void BSP_LED_AllOff(void)
{
    LED_ALARM_R_OFF;
    LED_RUN_G_OFF;
    LED_FAULT_Y_OFF;
    LED_VBAT_R_OFF;
}

void BSP_LED_Init(void)
{
    BSP_LED_AllOff();

    led_task_id = TMOS_ProcessEventRegister(LED_Task_ProcessEvent);
    if (led_task_id == INVALID_TASK_ID)
    {
        logError("LED task register failed");
        return;
    }
    logInfo("BSP_LED_Init");
}

void LED_Ctrl(uint8_t led, uint8_t status)
{
    switch (led)
    {
        case 0:
            if (status)
            {
                BSP_LED_AllOn();
            }
            else
            {
                BSP_LED_AllOff();
            }
            break;

        case 1:
            if (status)
            {
                LED_ALARM_R_ON;
            }
            else
            {
                LED_ALARM_R_OFF;
            }
            break;

        case 2:
            if (status)
            {
                LED_RUN_G_ON;
            }
            else
            {
                LED_RUN_G_OFF;
            }
            break;

        case 3:
            if (status)
            {
                LED_FAULT_Y_ON;
            }
            else
            {
                LED_FAULT_Y_OFF;
            }
            break;
        case 4:
            if (status)
            {
                LED_VBAT_R_ON;
            }
            else
            {
                LED_VBAT_R_OFF;
            }
            break;

        default:
            break;
    }
}
SHELL_EXPORT_CMD(SHELL_CMD_PERMISSION(0) | SHELL_CMD_TYPE(SHELL_TYPE_CMD_FUNC),
                 LED_Ctrl, LED_Ctrl, "LED_Ctrl <led> <status>");
